// CISaver.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <Moebius/MoebiusStrip.h>
#include "GLWnd.h"
#include "SaverWnd.h"
#include "CISaver.h"
#include "CISaverDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCISaverApp

BEGIN_MESSAGE_MAP(CCISaverApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CCISaverApp construction

CCISaverApp::CCISaverApp()
{
	m_pglwnd=0;
	m_psvwnd=0;
}


// The one and only CCISaverApp object

CCISaverApp theApp;

CSGMb Scene;


// CCISaverApp initialization

BOOL CCISaverApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();
	SetRegistryKey("CISaver");
	CWinApp::InitInstance();
  AfxEnableControlContainer();
	CString cmdln=m_lpCmdLine;
	int pos=0;
	CString tok=cmdln.Tokenize(" :",pos);
	//AfxMessageBox(cmdln);
	if (    !tok.CompareNoCase("/s") 
    	||  !tok.CompareNoCase("-s") 
    	||  !tok.CompareNoCase("s"))
    {
			DoScreenSaver();      // Run as screen saver
	    return TRUE;
    }
		if (  !tok.CompareNoCase("/c") 
			||  !tok.CompareNoCase("-c") 
			||  !tok.CompareNoCase("c")	 
			)
    {
       // Run config with current window as parent
       DoSaverSetting();

      // Now just terminate
      return FALSE;
    }
		if (  !tok.CompareNoCase("/p")  
			||  !tok.CompareNoCase("-p") 
			||  !tok.CompareNoCase("p") )
    {
     // Run config with current window as parent
          DoSaverPreview();//CWnd::GetActiveWindow());

      // Now just terminate
      return TRUE;
    }

	//  Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CCISaverApp::DoSaverSetting(void)
{	
	CCISaverDlg dlg;
	
	//AfxMessageBox("DoSaverSetting");
	CString tok,cmdln=m_lpCmdLine;
	int pos=0;
	tok=cmdln.Tokenize(": ",pos); 	//AfxMessageBox(tok);
	tok=cmdln.Tokenize(": ",pos); 	//AfxMessageBox(tok);

	if(tok.GetLength()>0)
	{
		//AfxMessageBox(tok);
		TRACE("Second token in command line is '%s'\n",tok);
		CWnd* pParent = CWnd::FromHandle((HWND)atol(tok));
		ASSERT(pParent != NULL);
		//dlg.SetParent(pParent);
	}
  ReadSetting();
	dlg.m_names=names;
	dlg.m_select=Starting;
  m_pMainWnd = &dlg;
	if (dlg.DoModal() == IDOK)
	{
			TRACE("names size %i %i\n",names.size(),dlg.m_names.size());
			names=dlg.m_names;
			Starting=dlg.m_select;
      WriteSetting();
	}
}

void CCISaverApp::DoScreenSaver(void)
{	
	TRACE("CCISaverApp::DoScreenSaver()\n");
  m_psvwnd = new CSaverWnd;
  ReadSetting();
	m_psvwnd->Create();
	m_pMainWnd = m_psvwnd;
	TRACE("exiting CCISaverApp::DoScreenSaver(void)\n");
}

void CCISaverApp::DoSaverPreview(void)
{	
	CString tok,cmdln=m_lpCmdLine;
	int pos=0;
	tok=cmdln.Tokenize(" ",pos); //	AfxMessageBox(tok);
	tok=cmdln.Tokenize(" ",pos); //	AfxMessageBox(tok);
	TRACE("Second token in command line is '%s'\n",tok);
	CWnd* pParent = CWnd::FromHandle((HWND)atol(tok));
	ASSERT(pParent != NULL);
	CGLWnd* pWnd = new CGLWnd();
  ReadSetting();
  CRect rect;
	pParent->GetClientRect(&rect);
	pWnd->myCreate(NULL, WS_VISIBLE|WS_CHILD, rect, pParent,0);
	m_pMainWnd = pWnd;
}

void CCISaverApp::ReadSetting()
{
	names.clear();
	int i=0; 
	bool ended=false;

	while(!ended)
	 {
		 CString tmp;
		 CString buf; buf.Format("SaverName%03i",i);
		 tmp=GetProfileString("CISaver", buf, "");
		 if(tmp!=""){
			 names.push_back(tmp);
			 ++i;
			}
		 else  ended = true;
	 }
	 Starting=GetProfileInt("CISaver", "Starting", 0);
	 if(names.empty()) Init(CString());
	 else Init(names[Starting]);
}

void CCISaverApp::Init(CString &name)
{
	Scene.Clear();
	if(name!="" && (00==name.Right(3).CompareNoCase("xml")))
	{
		XmlDoc xml;
	  if(xml.read(LPCSTR (name) ))
		{
			Scene.root.XMLRead(xml.root(),&Scene);
			Scene.m->Generate();
		}
	}
}
void CCISaverApp::WriteSetting()
{
	for(unsigned i=0;i<names.size();++i)
	 {
		 CString buf; buf.Format("SaverName%03i",i);
		 WriteProfileString("CISaver", buf, names[i]);
	 }
	 CString buf; buf.Format("SaverName%03i",i);
	WriteProfileString("CISaver", buf, "");
	
	 WriteProfileInt("CISaver", "Starting", Starting);
}



int CCISaverApp::ExitInstance()
{
TRACE("Cleaning...\n\n" );
if(m_pglwnd) delete m_pglwnd;
if(m_psvwnd) delete m_psvwnd;

	return CWinApp::ExitInstance();
}
